summaryrefslogtreecommitdiff
path: root/Omni/Cloud/post-receive.sh
diff options
context:
space:
mode:
authorBen Sima <ben@bsima.me>2024-11-15 14:55:37 -0500
committerBen Sima <ben@bsima.me>2024-12-21 10:06:49 -0500
commit6513755670892983db88a6633b8c1ea6019c03d1 (patch)
tree44e9eccdb7a3a74ab7e96a8fee7572dd6a78dc73 /Omni/Cloud/post-receive.sh
parentae7b7e0186b5f2e0dcd4d5fac0a71fa264caedc2 (diff)
Re-namespace some stuff to Omni
I was getting confused about what is a product and what is internal infrastructure; I think it is good to keep those things separate. So I moved a bunch of stuff to an Omni namespace, actually most stuff went there. Only things that are explicitly external products are still in the Biz namespace.
Diffstat (limited to 'Omni/Cloud/post-receive.sh')
-rwxr-xr-xOmni/Cloud/post-receive.sh39
1 files changed, 39 insertions, 0 deletions
diff --git a/Omni/Cloud/post-receive.sh b/Omni/Cloud/post-receive.sh
new file mode 100755
index 0000000..179fbd0
--- /dev/null
+++ b/Omni/Cloud/post-receive.sh
@@ -0,0 +1,39 @@
+#!/usr/bin/env bash
+#
+# creates an archive of a git repo on push
+#
+# unfortunately the nixos gitolite module does not copy the 'commonHooks'
+# properly, so we have to manually deploy this like so:
+#
+# scp Omni/Cloud/post-receive \
+# root@simatime.com:/srv/git/.gitolite/hooks/common/post-receive
+#
+# One time only:
+#
+# ssh root@simatime.com "sudo -u git gitolite setup -ho"
+#
+# Also on first-time setup, might need to manually check the permissions are
+# correct on $webroot/archive or wherever else.
+#
+set -euo pipefail
+while read -r _ newrev refname
+do
+ if [[ -e ./git-daemon-export-ok ]]
+ then
+ repo=$(basename "$PWD" | sed 's/.git//g')
+ branch=$(git rev-parse --symbolic --abbrev-ref "$refname")
+ webroot="/srv/www/simatime.com/"
+ outdir="$webroot/archive/$repo/$branch"
+ mkdir -p "$outdir"
+ echo " making: https://simatime.com/archive/$repo/$branch/$newrev.tar.gz"
+ git archive "$branch" --prefix "$repo-$branch/" --format tar \
+ | gzip > "$outdir/$newrev.tar.gz"
+ echo " making: https://simatime.com/archive/$repo/$branch/$newrev.sha256"
+ hash=$(nix-prefetch-url --unpack file://"$outdir"/"$newrev".tar.gz 2>/dev/null)
+ echo "$hash" > "$outdir/$newrev.sha256"
+ echo " commit: $newrev"
+ echo " sha256: $hash"
+ echo "in omni: deps update $repo --branch $branch --rev $newrev --attribute sha256=$hash"
+ chmod -R 755 "$webroot/archive"
+ fi
+done